<?php
class config {
	protected $config_dir = "/mnt/dj";
	protected $vob_dir = "";
	protected $ramdrive = "";
	protected $homedir = "";
	protected $flashdir = "";
	private $streamlist = array();
	private $voblist = array();
	private $errormsg = array();

	function __construct() {
/** Config-File einlesen und Werte in Variablen speichern */
		$vars = $this->get_cfg_vars( $this->config_dir."/config", array( "RAMDRIVE", "HOMEDIR", "FLASHDIR" ) );
		$this->ramdrive = $vars["RAMDRIVE"];
		$this->homedir = $vars["HOMEDIR"];
		$this->vob_dir = $this->homedir."/vobs";
		$this->flashdir = $vars["FLASHDIR"];
	}

	protected function get_cfg_vars( $file, $variables ) {
		$_return = array();
		$fd = fopen( $file, "r" );
		while( !feof( $fd ) ) {
			$content = trim( fgets( $fd ) );
			foreach( $variables as $variable ) {
				if( substr( $content, 0, strlen( $variable ) + 1 ) == $variable."=" ) {
					$_return[ $variable ] = str_replace( array( ";", "\"" ), "", substr( $content, strlen( $variable ) + 1 ) );
				}
			}
		}
		fclose( $fd );
		return( $_return );
	}

	protected function replace_file_regex( $file, $regular_expression, $value ) {
		if( is_file( $file ) === true ) {
			$fd = fopen( $file, 'r' );
			$temp = tempnam( $this->ramdrive, 'tmp' );

			if( is_resource( $fd ) === true ) {
				while( feof( $fd ) === false ) {
					$line = fgets( $fd );
					$line = preg_replace( $regular_expression, $value, $line );
					file_put_contents( $temp, $line, FILE_APPEND );
				}
				fclose( $fd );
			}
			unlink( $file );
		}

		return( rename( $temp, $file ) );
	}

	protected function addError( $errmsg ) {
		if( is_string( $errmsg ) AND strlen( $errmsg ) > 0 ) {
			array_push( $this->errormsg, $errmsg );
			return( true );
		} else return( false );
	}

	public function get_errmsg() {
		return( $this->errormsg );
	}

	public function get_streamlist( $renew = false ) {
		if( $renew OR count( $this->streamlist ) == 0 ) {
			if( $fd = fopen( $this->homedir."/streamlist", "r" ) ) {
				$this->streamlist = array();
				while( ( $data = fgetcsv( $fd, 1000, "," ) ) !== FALSE ) {
					if( $data != NULL ) {
						$this->streamlist[$data[0]] = array( "URL" => $data[1], "VOB" => $data[2], "NAME" => $data[3] );
					}
				}
				fclose( $fd );
				return( $this->streamlist );
			} else return( false );
		} else return( $this->streamlist );
	}

	public function get_voblist( $renew = false ) {
		if( $renew OR count( $this->voblist ) == 0 ) {
			if( $fd = opendir( $this->vob_dir ) ) {
				$this->voblist = array();
				while( ( $file = readdir( $fd ) ) !== false ) {
					if( !is_dir( $this->vob_dir."/$file" ) ) {
						array_push( $this->voblist, $file );
					}
				}
				sort( $this->voblist );
				return( $this->voblist );
			} else return( false );
		} else return( $this->voblist );
	}

}
?>